searchData={"items":[{"type":"module","title":"Membrane.Agora.Dispatcher","doc":"This element allows for dispatching the streams received by the `Membrane.Agora.Source`\nbased on the `user_id` field from the buffer's metadata.\nThe `Membrane.Agora.Source` sends a single stream for all the users that are present in the\nAgora channel and enriches buffers with the `user_id` field which corresponds\nto the ID of the stream sender from the Agora channel. The `Membrane.Agora.Dispatcher` element allows\nto demultiplex such a single output channel stream into multiple streams for each of the users.\n\nUsage:\n* attach the `Membrane.Agora.Dispatcher` element to each output pad of the `Membrane.Agora.Source`.\n* when the `{:add_pad,  }` message is received from a given `Membrane.Agora.Dispatcher` dispatcher,\nattach the output pad with the following name: `{:output,  }` to this particular dispatcher","ref":"Membrane.Agora.Dispatcher.html"},{"type":"module","title":"Element options - Membrane.Agora.Dispatcher","doc":"Passed via struct `t:Membrane.Agora.Dispatcher.t/0`\n\n- `queue_before_pad_connected?`  \n\n  ```\n  boolean()\n  ```\n  \n  Default value: `true`  \n  If true, the buffers will be queued until the corresponding pad, on which they should be sent, is connected.\n  Otherwise, if there is no corresponding pad available, the buffers are discarded.\n  Defaults to true.","ref":"Membrane.Agora.Dispatcher.html#module-element-options"},{"type":"module","title":"Pads - Membrane.Agora.Dispatcher","doc":"### `:input`\n\nAccepted formats:\n```\n%Membrane.H264{alignment: :au}\n```\n```\n%Membrane.RawAudio{sample_rate: 44100, channels: 2, sample_format: :s16le}\n```\n\nDirection: | `:input`\nAvailability: | `:always`\nFlow control: | `:auto`\n\n\n### `:output`\n\nAccepted formats:\n```\n%Membrane.H264{alignment: :au}\n```\n```\n%Membrane.RawAudio{sample_rate: 44100, channels: 2, sample_format: :s16le}\n```\n\nDirection: | `:output`\nAvailability: | `:on_request`\nFlow control: | `:auto`","ref":"Membrane.Agora.Dispatcher.html#module-pads"},{"type":"function","title":"Membrane.Agora.Dispatcher.options/0","doc":"Returns description of options available for this module","ref":"Membrane.Agora.Dispatcher.html#options/0"},{"type":"type","title":"Membrane.Agora.Dispatcher.t/0","doc":"Struct containing options for `Membrane.Agora.Dispatcher`","ref":"Membrane.Agora.Dispatcher.html#t:t/0"},{"type":"module","title":"Membrane.Agora.Sink","doc":"Membrane sink that wraps Agora's Server Gateway SDK.","ref":"Membrane.Agora.Sink.html"},{"type":"module","title":"Element options - Membrane.Agora.Sink","doc":"Passed via struct `t:Membrane.Agora.Sink.t/0`\n\n- `app_id`  \n\n  ```\n  String.t()\n  ```\n  \n  ***Required***  \n  ID of an Agora application.\n\n\n- `channel_name`  \n\n  ```\n  String.t()\n  ```\n  \n  ***Required***  \n  \n\n\n\n- `token`  \n\n  ```\n  String.t()\n  ```\n  \n  ***Required***  \n  \n\n\n\n- `user_id`  \n\n  ```\n  String.t()\n  ```\n  \n  Default value: `\"0\"`  \n  User ID, must contain only numbers (0-9).\n  \n    If set to \"0\" (default), the user ID will be chosen automatically.","ref":"Membrane.Agora.Sink.html#module-element-options"},{"type":"module","title":"Pads - Membrane.Agora.Sink","doc":"### `:audio`\n\nAccepted formats:\n```\nMembrane.AAC\n```\n\nDirection: | `:input`\nAvailability: | `:on_request`\nFlow control: | `:auto`\n\n\n### `:video`\n\nAccepted formats:\n```\n%Membrane.H264{alignment: :au}\n```\n\nDirection: | `:input`\nAvailability: | `:on_request`\nFlow control: | `:auto`","ref":"Membrane.Agora.Sink.html#module-pads"},{"type":"function","title":"Membrane.Agora.Sink.options/0","doc":"Returns description of options available for this module","ref":"Membrane.Agora.Sink.html#options/0"},{"type":"type","title":"Membrane.Agora.Sink.t/0","doc":"Struct containing options for `Membrane.Agora.Sink`","ref":"Membrane.Agora.Sink.html#t:t/0"},{"type":"module","title":"Membrane.Agora.Source","doc":"Membrane source that wraps Agora's Server Gateway SDK.","ref":"Membrane.Agora.Source.html"},{"type":"module","title":"Element options - Membrane.Agora.Source","doc":"Passed via struct `t:Membrane.Agora.Source.t/0`\n\n- `app_id`  \n\n  ```\n  String.t()\n  ```\n  \n  ***Required***  \n  ID of an Agora application.\n\n\n- `channel_name`  \n\n  ```\n  String.t()\n  ```\n  \n  ***Required***  \n  \n\n\n\n- `token`  \n\n  ```\n  String.t()\n  ```\n  \n  ***Required***  \n  \n\n\n\n- `user_id`  \n\n  ```\n  String.t()\n  ```\n  \n  Default value: `\"0\"`  \n  User ID, must contain only numbers (0-9).\n  \n    If set to \"0\" (default), the user ID will be chosen automatically.","ref":"Membrane.Agora.Source.html#module-element-options"},{"type":"module","title":"Pads - Membrane.Agora.Source","doc":"### `:audio`\n\nAccepted formats:\n```\n%Membrane.RawAudio{sample_rate: 44100, channels: 2, sample_format: :s16le}\n```\n\nDirection: | `:output`\nAvailability: | `:always`\nFlow control: | `:push`\n\n\n### `:video`\n\nAccepted formats:\n```\n%Membrane.H264{alignment: :au}\n```\n\nDirection: | `:output`\nAvailability: | `:always`\nFlow control: | `:push`","ref":"Membrane.Agora.Source.html#module-pads"},{"type":"function","title":"Membrane.Agora.Source.options/0","doc":"Returns description of options available for this module","ref":"Membrane.Agora.Source.html#options/0"},{"type":"type","title":"Membrane.Agora.Source.t/0","doc":"Struct containing options for `Membrane.Agora.Source`","ref":"Membrane.Agora.Source.html#t:t/0"},{"type":"extras","title":"Membrane Agora Plugin","doc":"# Membrane Agora Plugin\n\n[![Hex.pm](https://img.shields.io/hexpm/v/membrane_agora_plugin.svg)](https://hex.pm/api/packages/membrane_agora_plugin)\n[![Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/membrane_agora_plugin/)\n[![CircleCI](https://circleci.com/gh/membraneframework/bundlex.svg?style=svg)](https://circleci.com/gh/membraneframework/bundlex)\n\nThis repository contains Membrane Agora Plugin, which wraps:\n[Agora Server Gateway](https://docs.agora.io/en/server-gateway/overview/product-overview?platform=linux-cpp).\nCurrently only `Membrane.Agora.Sink` is available.","ref":"readme.html"},{"type":"extras","title":"Installation - Membrane Agora Plugin","doc":"The Agora's Gateway server SDK is available only for Ubuntu (14.04 or higher) and\nCentOS (6.6 or higher) operating systems, and so is membrane_agora_plugin.\nThe required CPU architecture is arm64 or x86-64.\n\nYou can use the `membraneframeworklabs/docker_membrane` docker image (in version `v2.2.0-rc2` or higher) as a running environment:\n```\ndocker run -it membraneframeworklabs/docker_membrane\n```\n\nTo use that plugin in your project, add the following line to your deps in `mix.exs`:\n```\n\t{:membrane_agora_plugin, \"~> 0.2.4\"}\n```\n\nRun `mix deps.get`.\n\nThen you need to set the LD_LIBRARY_PATH:\n```\nexport LD_LIBRARY_PATH=$LD_LIBRARY_PATH: /membrane_agora_plugin/agora_sdk\n```\n\nAs an example, you can run the `example.exs` script to see `Membrane.Agora.Sink` in action.\nFirst you need to configure the following Agora's specific environmental variables:\n```bash\n  export AGORA_CHANNEL_NAME= \n  export AGORA_TOKEN= \n  export AGORA_APP_ID= \n  export AGORA_USER_ID= \n```\n[Here](https://docs.agora.io/en/server-gateway/reference/manage-agora-account?platform=linux-cpp) you can read how to obtain these values.\n\nThen run the exemplary [web demo application](https://webdemo.agora.io/basicVideoCall/index.html) (you can read about it [here](https://docs.agora.io/en/server-gateway/get-started/integrate-sdk?platform=linux-cpp#use-the-client-to-receive-streams-sent-from-the-server)).\nRemember that you need to use the same Agora parameters as you have specified in the environmental variables.\n\nFinaly, type:\n```\nexport LD_LIBRARY_PATH=$LD_LIBRARY_PATH: /membrane_agora_plugin/agora_sdk\nelixir example.exs\n```\nand observe the web demo application.\nOnce the pipeline is started, audio and video should start playing.","ref":"readme.html#installation"},{"type":"extras","title":"Provide your own SDK - Membrane Agora Plugin","doc":"By default, the plugin will attempt to download the correct SDK for your system. However, if you want to bundle the SDK code yourself, you can provide the environment variable `AGORA_SDK_PRESENT` set to \"true\". This flag will prevent the bundlex config from pulling the SDK during build time. However, it is up to you to set the correct paths to the SDK for build and compile time using the correct flags for your C compiler.","ref":"readme.html#provide-your-own-sdk"},{"type":"extras","title":"Copyright and License - Membrane Agora Plugin","doc":"Copyright 2022, [Software Mansion](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane_template_plugin)\n\n[![Software Mansion](https://logo.swmansion.com/logo?color=white&variant=desktop&width=200&tag=membrane-github)](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane_template_plugin)\n\nLicensed under the [Apache License, Version 2.0](LICENSE)","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2020 Software Mansion\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}